// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/Stats.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class Stats extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inQuotes = 2;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1, 1
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\2\0\1\1\23\0\1\1\5\0\1\2"+
    "\10\0\1\3\12\0\1\4\1\5\1\6\1\0\1\7"+
    "\2\0\1\10\1\11\1\12\1\0\1\13\1\14\1\15"+
    "\1\0\1\16\1\0\1\17\1\20\1\21\1\22\1\23"+
    "\1\24\1\0\1\25\1\26\1\27\1\30\1\31\3\0"+
    "\1\32\4\0\1\33\1\0\1\10\1\11\1\12\1\0"+
    "\1\13\1\14\1\15\1\0\1\16\1\0\1\17\1\20"+
    "\1\21\1\22\1\23\1\24\1\0\1\25\1\26\1\27"+
    "\1\30\1\31\3\0\1\32\265\0\2\16\115\0\1\26"+
    "\u0182\0\1\1\u0127\0\1\17\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\2\0\3\1\165\0\1\2\2\0\1\3\14\0\1\4"+
    "\2\0\1\5\12\0\1\6\4\0\1\7\22\0\1\10"+
    "\6\0\1\11\5\0\1\12\6\0\1\13\2\0\1\14"+
    "\4\0\1\15\5\0\1\16\2\0\1\17\3\0\1\20"+
    "\11\0\1\21\6\0\1\22\4\0\1\23\2\0\1\24"+
    "\7\0\1\25\7\0\1\26\1\0\1\27\1\30\3\0"+
    "\1\31\10\0\1\32\1\0\1\33";

  private static int [] zzUnpackAction() {
    int [] result = new int[277];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\34\0\70\0\124\0\160\0\214\0\250\0\304"+
    "\0\340\0\374\0\u0118\0\u0134\0\u0150\0\u016c\0\u0188\0\u01a4"+
    "\0\u01c0\0\u01dc\0\u01f8\0\u0214\0\u0230\0\u024c\0\u0268\0\u0284"+
    "\0\u02a0\0\u02bc\0\u02d8\0\u02f4\0\u0310\0\u032c\0\u0348\0\u0364"+
    "\0\u0380\0\u039c\0\u03b8\0\u03d4\0\u03f0\0\u040c\0\u0428\0\u0444"+
    "\0\u0460\0\u047c\0\u0498\0\u04b4\0\u04d0\0\u04ec\0\u0508\0\u0524"+
    "\0\u0540\0\u055c\0\u0578\0\u0594\0\u05b0\0\u05cc\0\u05e8\0\u0604"+
    "\0\u0620\0\u063c\0\u0658\0\u0674\0\u0690\0\u06ac\0\u06c8\0\u06e4"+
    "\0\u0700\0\u071c\0\u0738\0\u0754\0\u0770\0\u078c\0\u07a8\0\u07c4"+
    "\0\u07e0\0\u07fc\0\u0818\0\u0834\0\u0850\0\u086c\0\u0888\0\u08a4"+
    "\0\u08c0\0\u08dc\0\u08f8\0\u0914\0\u0930\0\u094c\0\u0968\0\u0984"+
    "\0\u09a0\0\u09bc\0\u09d8\0\u09f4\0\u0a10\0\u0a2c\0\u0a48\0\u0a64"+
    "\0\u0a80\0\u0a9c\0\u0ab8\0\u0ad4\0\u0af0\0\u0b0c\0\u0b28\0\u0b44"+
    "\0\u0b60\0\u0b7c\0\u0b98\0\u0bb4\0\u0bd0\0\u0bec\0\u0c08\0\u0c24"+
    "\0\u0c40\0\u0c5c\0\u0c78\0\u0c94\0\u0cb0\0\u0ccc\0\u0ce8\0\u0d04"+
    "\0\u0d20\0\u0d3c\0\70\0\u0d58\0\u0d74\0\70\0\u0d90\0\u0dac"+
    "\0\u0dc8\0\u0de4\0\u0e00\0\u0e1c\0\u0e38\0\u0e54\0\u0e70\0\u0e8c"+
    "\0\u0ea8\0\u0ec4\0\70\0\u0ee0\0\u0efc\0\70\0\u0f18\0\u0f34"+
    "\0\u0f50\0\u0f6c\0\u0f88\0\u0fa4\0\u0fc0\0\u0fdc\0\u0ff8\0\u1014"+
    "\0\70\0\u1030\0\u104c\0\u1068\0\u1084\0\70\0\u10a0\0\u10bc"+
    "\0\u10d8\0\u10f4\0\u1110\0\u112c\0\u1148\0\u1164\0\u1180\0\u119c"+
    "\0\u11b8\0\u11d4\0\u11f0\0\u120c\0\u1228\0\u1244\0\u1260\0\u127c"+
    "\0\70\0\u1298\0\u12b4\0\u12d0\0\u12ec\0\u1308\0\u1324\0\70"+
    "\0\u1340\0\u135c\0\u1378\0\u1394\0\u13b0\0\70\0\u13cc\0\u13e8"+
    "\0\u1404\0\u1420\0\u143c\0\u1458\0\70\0\u1474\0\u1490\0\70"+
    "\0\u14ac\0\u14c8\0\u14e4\0\u1500\0\70\0\u151c\0\u1538\0\u1554"+
    "\0\u1570\0\u158c\0\70\0\u15a8\0\u15c4\0\70\0\u15e0\0\u15fc"+
    "\0\u1618\0\70\0\u1634\0\u1650\0\u166c\0\u1688\0\u16a4\0\u16c0"+
    "\0\u16dc\0\u16f8\0\u1714\0\70\0\u1730\0\u174c\0\u1768\0\u1784"+
    "\0\u17a0\0\u17bc\0\70\0\u17d8\0\u17f4\0\u1810\0\u182c\0\70"+
    "\0\u1848\0\u1864\0\70\0\u1880\0\u189c\0\u18b8\0\u18d4\0\u18f0"+
    "\0\u190c\0\u1928\0\70\0\u1944\0\u1960\0\u197c\0\u1998\0\u19b4"+
    "\0\u19d0\0\u19ec\0\70\0\u1a08\0\70\0\70\0\u1a24\0\u1a40"+
    "\0\u1a5c\0\70\0\u1a78\0\u1a94\0\u1ab0\0\u1acc\0\u1ae8\0\u1b04"+
    "\0\u1b20\0\u1b3c\0\70\0\u1b58\0\70";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[277];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\6\3\1\4\33\3\1\5\25\3\55\0\1\6\15\0"+
    "\1\7\15\0\1\10\37\0\1\11\27\0\1\12\37\0"+
    "\1\13\25\0\1\14\41\0\1\15\25\0\1\16\20\0"+
    "\1\17\46\0\1\20\20\0\1\21\37\0\1\22\1\0"+
    "\1\23\5\0\1\24\1\0\1\25\1\0\1\26\1\0"+
    "\1\27\1\30\1\0\1\31\6\0\1\32\37\0\1\33"+
    "\1\0\1\34\5\0\1\35\1\0\1\36\1\0\1\37"+
    "\1\0\1\40\25\0\1\41\4\0\1\42\16\0\1\43"+
    "\12\0\1\44\23\0\1\45\2\0\1\46\45\0\1\47"+
    "\13\0\1\50\36\0\1\51\7\0\1\52\26\0\1\53"+
    "\33\0\1\54\46\0\1\55\27\0\1\56\16\0\1\57"+
    "\12\0\1\60\23\0\1\61\50\0\1\62\13\0\1\63"+
    "\36\0\1\64\7\0\1\65\30\0\1\66\42\0\1\67"+
    "\30\0\1\70\30\0\1\71\41\0\1\72\15\0\1\73"+
    "\43\0\1\74\37\0\1\75\40\0\1\76\30\0\1\77"+
    "\33\0\1\100\31\0\1\101\24\0\1\102\44\0\1\103"+
    "\30\0\1\104\30\0\1\105\41\0\1\106\25\0\1\107"+
    "\37\0\1\110\40\0\1\111\30\0\1\112\17\0\1\113"+
    "\36\0\1\114\40\0\1\115\31\0\1\116\41\0\1\117"+
    "\31\0\1\120\21\0\1\121\30\0\1\122\12\0\1\123"+
    "\3\0\1\124\22\0\1\125\44\0\1\126\27\0\1\127"+
    "\25\0\1\130\43\0\1\131\24\0\1\132\40\0\1\133"+
    "\31\0\1\134\41\0\1\135\17\0\1\136\30\0\1\137"+
    "\41\0\1\140\44\0\1\141\21\0\1\142\30\0\1\143"+
    "\21\0\7\144\1\0\24\144\10\0\1\145\36\0\1\146"+
    "\43\0\1\147\35\0\1\150\23\0\1\151\36\0\1\152"+
    "\26\0\1\153\43\0\1\154\33\0\1\155\30\0\1\156"+
    "\36\0\1\157\25\0\1\160\30\0\1\161\21\0\7\162"+
    "\1\0\24\162\10\0\1\163\36\0\1\164\45\0\1\165"+
    "\23\0\1\166\41\0\1\167\33\0\1\170\20\0\1\171"+
    "\46\0\1\172\10\0\7\144\1\173\24\144\1\0\1\174"+
    "\1\175\4\0\1\176\51\0\1\177\6\0\7\200\1\0"+
    "\24\200\23\0\1\201\35\0\1\202\21\0\1\203\20\0"+
    "\7\204\1\0\24\204\22\0\1\205\33\0\1\206\34\0"+
    "\1\207\30\0\1\210\36\0\1\211\33\0\1\212\10\0"+
    "\7\162\1\213\24\162\1\0\1\214\1\215\4\0\1\216"+
    "\51\0\1\217\31\0\1\220\35\0\1\221\30\0\1\222"+
    "\33\0\1\223\40\0\1\224\24\0\1\225\13\0\7\226"+
    "\1\0\24\226\22\0\1\227\21\0\1\230\23\0\7\200"+
    "\1\231\24\200\7\232\1\0\10\232\1\233\13\232\10\0"+
    "\1\234\56\0\1\235\7\204\1\236\24\204\13\0\1\237"+
    "\50\0\1\240\3\0\7\241\1\0\24\241\13\0\1\242"+
    "\40\0\1\243\33\0\1\244\13\0\7\245\1\0\24\245"+
    "\22\0\1\246\21\0\1\247\23\0\7\250\1\0\10\250"+
    "\1\251\13\250\10\0\1\252\36\0\1\253\50\0\1\254"+
    "\26\0\1\255\33\0\1\256\10\0\7\226\1\176\24\226"+
    "\11\0\1\257\22\0\7\260\1\0\24\260\7\232\1\261"+
    "\33\232\1\261\1\262\23\232\14\0\1\263\35\0\1\264"+
    "\7\0\1\265\5\0\7\266\1\0\24\266\21\0\1\267"+
    "\12\0\7\241\1\270\24\241\27\0\1\271\17\0\1\272"+
    "\43\0\1\273\10\0\7\245\1\216\24\245\11\0\1\274"+
    "\22\0\7\275\1\0\24\275\7\250\1\276\33\250\1\276"+
    "\1\277\23\250\14\0\1\300\17\0\7\301\1\0\24\301"+
    "\21\0\1\302\13\0\1\303\1\304\4\0\1\305\24\0"+
    "\7\306\1\0\24\306\26\0\1\307\5\0\7\260\1\310"+
    "\24\260\7\232\1\261\17\232\1\311\4\232\23\0\1\312"+
    "\32\0\1\313\34\0\1\314\10\0\7\266\1\315\24\266"+
    "\13\0\1\316\47\0\1\317\33\0\1\320\4\0\7\321"+
    "\1\0\24\321\26\0\1\322\5\0\7\275\1\323\24\275"+
    "\7\250\1\276\17\250\1\324\4\250\23\0\1\325\10\0"+
    "\7\301\1\326\24\301\13\0\1\327\20\0\7\330\1\0"+
    "\24\330\22\0\1\331\11\0\7\306\1\332\24\306\24\0"+
    "\1\333\7\0\7\232\1\261\6\232\1\334\15\232\7\335"+
    "\1\0\24\335\26\0\1\336\31\0\1\337\1\0\1\340"+
    "\32\0\1\341\21\0\1\342\47\0\1\343\4\0\7\321"+
    "\1\344\24\321\24\0\1\345\7\0\7\250\1\276\6\250"+
    "\1\346\15\250\7\347\1\0\24\347\25\0\1\350\6\0"+
    "\7\330\1\305\24\330\11\0\1\351\27\0\1\174\26\0"+
    "\7\232\1\261\12\232\1\352\11\232\7\335\1\353\24\335"+
    "\13\0\1\354\44\0\1\355\36\0\1\356\27\0\1\357"+
    "\17\0\1\360\37\0\1\361\25\0\1\214\26\0\7\250"+
    "\1\276\12\250\1\362\11\250\7\347\1\363\24\347\23\0"+
    "\1\364\36\0\1\365\5\0\7\232\1\261\13\232\1\366"+
    "\10\232\25\0\1\367\33\0\1\370\24\0\1\371\15\0"+
    "\7\372\1\0\24\372\7\0\1\373\24\0\7\250\1\276"+
    "\13\250\1\374\10\250\7\375\1\0\24\375\24\0\1\376"+
    "\7\0\7\377\1\261\24\377\16\0\1\u0100\30\0\1\u0101"+
    "\47\0\1\u0102\4\0\7\372\1\u0103\24\372\7\u0104\1\276"+
    "\24\u0104\7\375\1\u0105\24\375\5\0\1\303\26\0\7\377"+
    "\1\u0106\24\377\21\0\1\u0107\40\0\1\u0108\35\0\1\u0109"+
    "\3\0\7\u0104\1\u010a\24\u0104\13\0\1\u010b\46\0\1\u010c"+
    "\37\0\1\u010c\23\0\1\u010d\27\0\1\u010e\44\0\1\u010f"+
    "\27\0\1\u0110\33\0\1\u0111\32\0\1\u0112\20\0\1\u0113"+
    "\37\0\1\u0114\27\0\1\u0115\24\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[7028];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\2\0\1\11\2\1\165\0\1\11\2\0\1\11\14\0"+
    "\1\11\2\0\1\11\12\0\1\11\4\0\1\11\22\0"+
    "\1\11\6\0\1\11\5\0\1\11\6\0\1\11\2\0"+
    "\1\11\4\0\1\11\5\0\1\11\2\0\1\11\3\0"+
    "\1\11\11\0\1\11\6\0\1\11\4\0\1\11\2\0"+
    "\1\11\7\0\1\11\7\0\1\11\1\0\2\11\3\0"+
    "\1\11\10\0\1\11\1\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[277];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	Stats() { }
	
	public int libri = 0;
	public int parti = 0;
	public int titoli = 0;
	public int capi = 0;
	public int sezioni = 0;
	public int articoli = 0;
	public int commi = 0;
	public int paragrafi = 0;
	public int lettere = 0;
	public int latins = 0;
	public int numeri = 0;
	public int subnumeri = 0;
	
	public int allegati = 0;
	
	public int virgolette = 0;
	
	public int inserimenti = 0;
	public int soppressioni = 0;
	
	//nelle virgolette:
	public int vcapi = 0;
	public int vsezioni = 0;
	public int varticoli = 0;
	public int vcommi = 0;
	public int vparagrafi = 0;
	public int vlettere = 0;
	public int vlatins = 0;
	public int vnumeri = 0;
	public int vsubnumeri = 0;
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public Stats(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { 
            }
          // fall through
          case 28: break;
          case 2:
            { capi++;
            }
          // fall through
          case 29: break;
          case 3:
            { commi++;
            }
          // fall through
          case 30: break;
          case 4:
            { vcapi++; capi++;
            }
          // fall through
          case 31: break;
          case 5:
            { vcommi++; commi++;
            }
          // fall through
          case 32: break;
          case 6:
            { libri++;
            }
          // fall through
          case 33: break;
          case 7:
            { parti++;
            }
          // fall through
          case 34: break;
          case 8:
            { numeri++;
            }
          // fall through
          case 35: break;
          case 9:
            { titoli++;
            }
          // fall through
          case 36: break;
          case 10:
            { vnumeri++; numeri++;
            }
          // fall through
          case 37: break;
          case 11:
            { allegati++;
            }
          // fall through
          case 38: break;
          case 12:
            { lettere++;
            }
          // fall through
          case 39: break;
          case 13:
            { sezioni++;
            }
          // fall through
          case 40: break;
          case 14:
            { vlettere++; lettere++;
            }
          // fall through
          case 41: break;
          case 15:
            { vsezioni++; sezioni++;
            }
          // fall through
          case 42: break;
          case 16:
            { articoli++;
            }
          // fall through
          case 43: break;
          case 17:
            { varticoli++; articoli++;
            }
          // fall through
          case 44: break;
          case 18:
            { paragrafi++;
            }
          // fall through
          case 45: break;
          case 19:
            { virgolette++;
	
	yybegin(inQuotes);
            }
          // fall through
          case 46: break;
          case 20:
            { vparagrafi++; paragrafi++;
            }
          // fall through
          case 47: break;
          case 21:
            { yybegin(0);
            }
          // fall through
          case 48: break;
          case 22:
            { subnumeri++;
            }
          // fall through
          case 49: break;
          case 23:
            { vsubnumeri++; subnumeri++;
            }
          // fall through
          case 50: break;
          case 24:
            { latins++;
            }
          // fall through
          case 51: break;
          case 25:
            { vlatins++; latins++;
            }
          // fall through
          case 52: break;
          case 26:
            { inserimenti++;
            }
          // fall through
          case 53: break;
          case 27:
            { soppressioni++;
            }
          // fall through
          case 54: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java Stats [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        Stats scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new Stats(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
